<template>
  <div
    class="dimension-card d-inline-block w-100 ecl-u-border-all ecl-u-border-width-1"
    :class="{ clickable: isClickable }">
    <div class="ecl-u-d-flex dimensions-item-head pb-0">
      <!-- Title -->
      <section class="score-summary">
        <h3
        v-if="identifier === 'score'"
        class="ecl-u-type-heading-3 ecl-u-type-color-blue card-title pt-0 pt-md-2 pb-2 text-center"
        :class="{ 'mb-0': true }"
      >
        <slot name="title" />
      </h3>
      <h4 v-else
        class="ecl-u-type-heading-4 ecl-u-type-color-blue card-title pt-0 pt-md-2 pb-2 text-center "
        :class="{ 'mb-0': true }"
      >
        <slot name="title" />
      </h4>
      <!-- Score -->
      <div
        v-if="!!$slots.score && identifier === 'score'"
        class="mb-2"
      >
        <slot
          name="score"
        >
          emptiness
        </slot>
      </div>
      <!-- Description -->
      <p v-if="$slots.default" class="card-text">
        <!-- Default slot for description text -->
        <slot />
      </p>
      </section>

      <div class="ecl-u-type-prolonged-l d-flex justify-content-center align-items-center px-3 score" :class="scoreClasses(scorePoints, identifier)">
        <div class="d-flex flex-column align-items-end">
          <div class="progress-bar-container">
            <div class="progress-bar-text"><b>{{ scorePoints }}</b> <span class="small-font">/{{ scoreBase }}</span></div>
            <div class="progress-bar-background">
              <div class="progress-bar-fill" :style="{ width: fillWidth, 'background-color': identifier === 'score' ? progressColor : '#007bff' }"></div>
            </div>
          </div>
        </div>
      </div>

    </div>
    <!-- Indicators -->
    <div v-if="identifier !== 'score'" class="indicators-list">
      <table>
        <tr>
          <th>{{ $t("message.methodology.dimensions.table.metric_name") }}</th>
          <th>{{ $t("message.methodology.dimensions.table.coverage") }}</th>
          <th></th>
          <th>{{ $t("message.methodology.dimensions.table.weight") }}</th>
          <th></th>
          <th>{{ $t("message.dashboard.points") }}</th>
        </tr>
      </table>
      <hr style="margin: 0px 0px 7px 0px;">
      <dimensions-item-indicator
        v-for="(_, key) in indicators"
        :key="key"
        :indicator="$t(`message.dashboard.${identifier}.plots.title.${key}`)"
        :indicator-tooltip="`${$t(`message.methodology.dimensions.${indicators[key].tooltipDescription}`)}<br><br>${$t(`message.methodology.dimensions.${indicators[key].tooltipMetrics}`)}`"
        :values="weightedIndicatorValues[key]"
        :filter-primary-value="indicators[key].primary"
        :display-name="indicators[key].displayName"
        data-html="true"
      />
    </div>
  </div>
</template>

<script>
import DimensionsItemIndicator from './DimensionsItemIndicator.vue'
import {mapGetters} from 'vuex'
import {maxScore, scoreClasses} from "./utils/score";

export default {
  name: 'DimensionsItem',
  components: { DimensionsItemIndicator },
  props: {
    // Identifier for this card
    identifier: {
      type: String,
      default () {
        return ''
      }
    },
    // Metric values for all indicator for this card
    indicatorValues: {
      // Must be Object (multiple indicators) or Number (for scoring card)
      type: [Object, Number],
      default () {
        return {}
      }
    },
    /**
     * Indicator attributes e.g. human readable labels
     */
    indicators: {
      type: Object,
      default () {
        return {}
      }
    },
    isClickable: {
      type: Boolean,
      default: true
    }
  },
  computed: {
    ...mapGetters([
      'metrics'
    ]),
    score() {
      const metrics = this.metrics[this.identifier];
      if(this.identifier==='score'){
        return metrics
      }
      return metrics ? metrics.score : null;
    },
    isAllNumbers() {
      return (str) => /^\d+$/.test(str);
    },
    scorePoints() {
      if (this.identifier === 'score') {
        return this.score
      }
      return this.score ? this.score.points : null;
    },
    scoreBase() {
      if ( ! this.score) return null;
      return maxScore(this.identifier)
    },
    progressColor() {
      if (this.scorePoints >= 351) {
        return 'blue';
      } else if (this.scorePoints >= 221) {
        return 'green';
      } else if (this.scorePoints >= 121) {
        return '#db5600';
      } else {
        return 'red';
      }
    },
    weightedIndicatorValues() {
      return this.addWeight();
    },
    fillWidth() {
      return (this.scorePoints / this.scoreBase) * 100 + '%';
    }
  },
  methods: {
    scoreClasses,
    addWeight() {
      const weights = {
        findability: {
          keywordAvailability: 30,
          categoryAvailability: 30,
          spatialAvailability: 20,
          temporalAvailability: 20
        },
        accessibility: {
          accessUrlAccessibility: 50,
          downloadUrlAvailability: 20,
          downloadUrlAccessibility: 30
        },
        interoperability: {
          dcatApCompliance: 30,
          formatAvailability: 20,
          formatMediaTypeAlignment: 10,
          formatMediaTypeMachineReadable: 20,
          formatMediaTypeNonProprietary: 20,
          mediaTypeAvailability: 10
        },
        reusability: {
          accessRightsAlignment: 5,
          accessRightsAvailability: 10,
          contactPointAvailability: 20,
          licenceAlignment: 10,
          licenceAvailability: 20,
          publisherAvailability: 10
        },
        contextuality: {
          byteSizeAvailability: 5,
          dateIssuedAvailability: 5,
          dateModifiedAvailability: 5,
          rightsAvailability: 5
        }
      };

      const updatedValues = { ...this.indicatorValues };

      if (weights[this.identifier]) {
        for (const key in updatedValues) {
          if (weights[this.identifier][key] !== undefined) {
            for (const subKey in updatedValues[key]) {
              if (subKey !== "weight" && updatedValues[key][subKey].hasOwnProperty("percentage")) {
                updatedValues[key][subKey].weight = weights[this.identifier][key];
              }
            }
          }
        }
      }
      return updatedValues;
    }
  }
};
</script>

<style lang="scss" scoped>
@import "../../styles/metrics-style.scss";

.score {
  min-width: 80px;
}

.score-points {
  font-weight: bold;
  line-height: normal;
}

.score-base {
  font-size: small;
  margin-left: 3px;
  line-height: normal;
}

.dimension-card {
  // Default background color to be overwritten
  background-color: #F3f6fc;
  color: rgba(white, 0.89);
  border-color: #e9eaeb !important;
  margin-bottom: 20px;
  border-radius: .25rem !important;
  cursor: pointer;

  &.clickable {
    transition: transform .4s ease;

    &:hover {
    transition: transform .4s ease;
    transform: scale(1.01);
    }

    &::after {
      content: '';
      position: absolute;
      z-index: -1;
      top: 0;
      right: 0;
      bottom: 0;
      right: 0;
      width: 100%;
      height: 100%;
      transition: opacity .5s cubic-bezier(.25, .8, .25, 1);
      box-shadow: 0 12px 24px rgba(0, 0, 0, 0.25), 0 4px 8px rgba(0, 0, 0, 0.22);
      opacity: 0;
    }

    &:hover::after {
      opacity: 1;
    }
  }

  .list-group {
    .list-group-item {
      margin-bottom: -1px;
      border: 0;
      background: #F5F5F5;
    }
  }

  .card-title {
    hyphens: auto;
    align-self: center;
    margin-left: 15px;
  }

}
.dimension-scoring {
  margin-bottom: 15px;
  border-left: 5px solid #0e47cb !important;
  border-radius: 4px 0 0 4px;
}

.dimensions-item-head{
  padding-top: 1rem;
  align-items: center;
  background-color: #f3f6fc;
  gap:1rem;
  display: flex;
  justify-content: space-between;
  padding-right: 1rem;

  .score-summary{
    display: flex;
    gap: 1rem;
  }
  .card-title{
    color: #0e47cb !important;
  }
  .score{
    background-color: transparent;
    color: #000;
    // border-bottom: 4px solid #0e47cb;
    display: flex !important;
    justify-content: end !important;
    border-radius: 2px;
    padding: 0 !important;
  }
  progress{
    height: 10px;
    width: 110px;
  }
}

.ecl-u-bg-blue-n, .ecl-btn, .ecl-u-border-all{
  border-radius: .25rem !important;
}

.indicators-list {
  width: 100%;
  padding: 5px 15px 5px 20px;
  gap: 15px;
  background-color: #f3f6fc;
}
.ecl-u-type-heading-4 {
  margin-left: 20px!important;
}

.progress-bar-container {
  width: 100%;
  position: relative;
  display: flex;
  flex-direction: column;
}

.progress-bar-text {
  position: absolute;
  right: 0;
  top: -27px;
  white-space: nowrap;
  color: #333;
}

.progress-bar-background {
  width: 100%;
  height: 4px;
  overflow: hidden;
  position: relative;
  background-color: white
}

.progress-bar-fill {
  height: 100%;
  transition: width 0.4s ease;
}

.small-font {
  font-size: 12px;
}

.d-flex.flex-column.align-items-end {
  width: 110px;
}

table {
  font-family: arial, sans-serif;
  border-collapse: collapse;
  width: 100%;
}
tr {
  height: 40px;
}
td, th {
  text-align: center;
  padding: 0;
}
th:first-child, td:first-child {
  width: 50%;
  text-align: left;
  padding-left: 10px;
}
th:last-child, td:last-child {
  width: 5% !important;
  text-align: right !important;
  padding-right: 10px;
}
th:not(:first-child), td:not(:first-child) {
  width: 11.25%;
}
@media only screen and (max-width: 1200px) {
  .indicators-list {
     grid-template-columns: auto auto;
  }
}
@media only screen and (max-width: 600px) {
  .indicators-list {
     grid-template-columns: auto;
  }
}
</style>
